/*** GRAFICOS.INC ***/

/* ---------------------------------------------------------------------- */

int cor_de_fundo = 7;       /* Variaveis globais que definem  */
int cor_dos_eixos = 4;      /* as cores do grafico            */
int cor_do_grafico = 2;
int mostra_intervalo = 1;   /* Determina se mostra a variacao do x e do y */

/* ---------------------------------------------------------------------- */

void IniciaModoGrafico(void) {

  /* Coloca a tela no modo grafico */

  int DriverGrafico, ModoGrafico;
  char Caminho[] = "C:\\LINGUAGE\\TC";  /* Subdiretorio dos arquivos .BGI */

  DriverGrafico = DETECT;
  initgraph(&DriverGrafico, &ModoGrafico, Caminho);
  if (graphresult() < 0) {
    printf("\nERRO na mudanca para o modo grafico.\n");
    exit(1);
  }
}

/* ---------------------------------------------------------------------- */

void DesenhaGrafico(float (*f)(float), int delta, float x1, float x2,
                    float y1, float y2) {

/* Constroi o grafico da funcao cujo nome deve ser fornecido como primei-
   ro parametro.  Quanto maior o delta, mais rapido e mais grosseiro e' o
   grafico. O intervalo [ x1, x2 ] corresponde `a variacao do x, enquanto
   que [ y1, y2 ] corresponde `a variacao do y.
   Exemplo: DesenhaGrafico(funcao_F, 2, -2.0, 5.0, -3.0, 10.0); */

  int A, B, ex, ey;
  float x, y;

  if (mostra_intervalo) {                /* Mostra na tela a variacao */
    char aux1[80], aux2[80], mens[80];   /* do x e do y               */
    sprintf(aux1, "%5.2f", x1);
    sprintf(aux2, "%5.2f", x2);
    sprintf(mens, "%s < x < %s", aux1, aux2);
    outtextxy(1, 1, mens);
    sprintf(aux1, "%5.2f", y1);
    sprintf(aux2, "%5.2f", y2);
    sprintf(mens, "%s < y < %s", aux1, aux2);
    outtextxy(1, 10, mens);
  }

  ex = (getmaxy()*y2)/(y2 - y1);
  ey = (getmaxx()*x1)/(x1 - x2);

  setbkcolor(cor_de_fundo);
  setcolor(cor_dos_eixos);
  line(0, ex, getmaxx(), ex);  /* Desenha o eixo x       */
  if (abs(y1) == abs(y2))
    outtextxy(getmaxx() - 10, getmaxy()/2 + 2, "x");

  line(ey, 0, ey, getmaxy());  /* Desenha o eixo y       */
  if (abs(x1) == abs(x2))
    outtextxy(getmaxx()/2 + 12, 0, "y");

  A = 0;                        /* Construcao do grafico */
  setcolor(cor_do_grafico);
  do {
    x = x1 + (x2 - x1)*A/((float) getmaxx());
    y = (*f)(x);
    B = getmaxy()*(y2 - y)/(y2 - y1);
    if (A == 0) moveto(A, B); else lineto(A, B);
    A += delta;
  } while (A <= getmaxx());
}

/* ---------------------------------------------------------------------- */

/*** FIM DE GRAFICOS.INC ***/
